Debian Bug report logs - #165897
dpkg doesn't compile with recent glibc and gcc

version graph

Package: libncurses5-dev; Maintainer for libncurses5-dev is Craig Small <csmall@debian.org>; Source for libncurses5-dev is src:ncurses.

Reported by: Koblinger Egmont <egmont@cs.bme.hu>

Date: Tue, 22 Oct 2002 14:18:02 UTC

Severity: normal

Fixed in version ncurses/5.3.20021109-1

Done: Daniel Jacobowitz <dan@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#165897; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Koblinger Egmont <egmont@cs.bme.hu>:
New Bug report received and forwarded. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Koblinger Egmont <egmont@cs.bme.hu>
To: submit@bugs.debian.org
Subject: dpkg doesn't compile with recent glibc and gcc
Date: Tue, 22 Oct 2002 16:03:32 +0200 (CEST)
Package: dpkg
Version: 1.9.21

Dpkg fails to compile with newest gcc (3.2) and glibc (2.3.1).
With gcc-3.2 and glibc-2.3 it was okay.

I've already compiled hundreds of applications with the newest gcc and
glibc, so I really doubt it's a glibc bug. (It can be, though.)

Here's the end of the compile messages:

make[1]: Entering directory `/build/work/compile/utils'
make[1]: Nothing to be done for `all'.
make[1]: Leaving directory `/build/work/compile/utils'
make[1]: Entering directory `/build/work/compile/dselect'
c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c basecmds.cc
c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c baselist.cc
c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c basetop.cc
c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c bindings.cc
cursesfile=`echo '#include <curses.h>' | \
         gcc -E - | grep 'curses.h' | head -1 | \
         sed -e 's/^[^"]*"//; s/".*$//'`; \
if [ "$cursesfile" = "" ]; then echo "can't find curses file"; exit 1; fi; \
perl ./mkcurkeys.pl keyoverride $cursesfile > curkeys.h
c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c curkeys.cc
In file included from curkeys.cc:31:
curkeys.h:168: `KEY_EVENT' was not declared in this scope
make[1]: *** [curkeys.o] Error 1
make[1]: Leaving directory `/build/work/compile/dselect'
make: *** [all-recursive] Error 2




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#165897; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Koblinger Egmont <egmont@cs.bme.hu>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #10 received at 165897@bugs.debian.org (full text, mbox):

From: Koblinger Egmont <egmont@cs.bme.hu>
To: 165897@bugs.debian.org
Subject: temporary fix
Date: Sat, 26 Oct 2002 13:10:48 +0200 (CEST)
hi,

The following patch causes dselect to compile. The resulted binary is able
to start correctly, however, I didn't further test is.

Now I'm not sure at all to which component of the system this problem is
related to.

Relevant part of /usr/lib/gcc-lib/i386-pc-linux-gnu/3.2/include/curses.h
looks as this:
#define KEY_EVENT       0633
/* ..... */
#ifndef NCURSES_WGETCH_EVENTS
#undef KEY_EVENT
#endif

So it seems that NCURSES_WGETCH_EVENTS is not defined for me. I use
ncurses-5.3, my gcc was compiled with this ncurses version, too.

Maybe I could fix it by passing some compile options to ncurses and then
recompile gcc as well... God knows. Anyway, dpkg should handle the
possibility of NCURSES_WGETCH_EVENTS not being defined.

(ps. I'm not using Debian, only dpkg...)

Here's my quick & dirty & ugly patch:


diff -urN dpkg-1.9.21.orig/dselect/Makefile.in dpkg-1.9.21/dselect/Makefile.in
--- dpkg-1.9.21.orig/dselect/Makefile.in	2001-04-24 13:02:50.000000000 +0200
+++ dpkg-1.9.21/dselect/Makefile.in	2002-10-26 12:38:36.000000000 +0200
@@ -60,4 +60,4 @@
 		 $(CC) -E - | grep 'curses.h' | head -1 | \
 		 $(SED) -e 's/^[^"]*"//; s/".*$$//'`; \
 	if [ "$$cursesfile" = "" ]; then echo "can't find curses file"; exit 1; fi; \
-	perl $(srcdir)/mkcurkeys.pl $< $$cursesfile > $@
+	perl $(srcdir)/mkcurkeys.pl $< $$cursesfile | grep -v KEY_EVENT > $@




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#165897; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Adam Heath <adam@lapdoog.doogie.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #15 received at 165897@bugs.debian.org (full text, mbox):

From: Adam Heath <adam@lapdoog.doogie.org>
To: Koblinger Egmont <egmont@cs.bme.hu>, <165897@bugs.debian.org>
Subject: Re: Bug#165897: dpkg doesn't compile with recent glibc and gcc
Date: Sat, 26 Oct 2002 17:25:07 -0500 (CDT)
reassign 165897 libncurses5-dev
thanks

On Tue, 22 Oct 2002, Koblinger Egmont wrote:

> Dpkg fails to compile with newest gcc (3.2) and glibc (2.3.1).
> With gcc-3.2 and glibc-2.3 it was okay.
>
> I've already compiled hundreds of applications with the newest gcc and
> glibc, so I really doubt it's a glibc bug. (It can be, though.)
>
> Here's the end of the compile messages:
>
> make[1]: Entering directory `/build/work/compile/utils'
> make[1]: Nothing to be done for `all'.
> make[1]: Leaving directory `/build/work/compile/utils'
> make[1]: Entering directory `/build/work/compile/dselect'
> c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c basecmds.cc
> c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c baselist.cc
> c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c basetop.cc
> c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c bindings.cc
> cursesfile=`echo '#include <curses.h>' | \
>          gcc -E - | grep 'curses.h' | head -1 | \
>          sed -e 's/^[^"]*"//; s/".*$//'`; \
> if [ "$cursesfile" = "" ]; then echo "can't find curses file"; exit 1; fi; \
> perl ./mkcurkeys.pl keyoverride $cursesfile > curkeys.h
> c++ -g -O2  -Wall -Wno-implicit -Wwrite-strings -Wpointer-arith -Wimplicit -Wnested-externs -DHAVE_CONFIG_H -D_GNU_SOURCE -DLOCALEDIR=\"/usr/share/locale\" -I../intl -I../intl -I../include -I.. -I. -I../include -I.. -I. -I../optlib -DUSE_ZLIB  -g -O2 -c curkeys.cc
> In file included from curkeys.cc:31:
> curkeys.h:168: `KEY_EVENT' was not declared in this scope
> make[1]: *** [curkeys.o] Error 1
> make[1]: Leaving directory `/build/work/compile/dselect'
> make: *** [all-recursive] Error 2

Looks like an ncurses bug to me.




Bug reassigned from package `dpkg' to `libncurses5-dev'. Request was from Adam Heath <adam@lapdoog.doogie.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to ncurses@packages.qa.debian.org:
Bug#165897; Package libncurses5-dev. Full text and rfc822 format available.

Acknowledgement sent to dickey@herndon4.his.com:
Extra info received and filed, but not forwarded. Copy sent to ncurses@packages.qa.debian.org. Full text and rfc822 format available.

Message #22 received at 165897-quiet@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@herndon4.his.com>
To: Debian Bug Tracking System <owner@bugs.debian.org>
Cc: Adam Heath <adam@lapdoog.doogie.org>, Daniel Jacobowitz <ncurses-maint@debian.org>, Dpkg Development <debian-dpkg@lists.debian.org>
Subject: Re: Processed: Re: Bug#165897: dpkg doesn't compile with recent glibc and gcc
Date: Sat, 26 Oct 2002 19:18:02 -0400
On Sat, Oct 26, 2002 at 05:33:26PM -0500, Debian Bug Tracking System wrote:
> Processing commands for control@bugs.debian.org:
> 
> > reassign 165897 libncurses5-dev
> Bug#165897: dpkg doesn't compile with recent glibc and gcc
> Bug reassigned from package `dpkg' to `libncurses5-dev'.

The fix should be in dpkg.  ncurses builds curses.h, reserving space for a
feature which is not used after all (and is removed to prevent unintentional
use).  dpkg builds a list of all of the KEY_xxx definitions without noting that
one is undefined later.  The same problem would occur (given dpkg's script) if
one of those KEY_xxx definitions were in an ifdef.

dpkg should simply ignore that, since it does not use the feature.

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net




Reply sent to Daniel Jacobowitz <dan@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Koblinger Egmont <egmont@cs.bme.hu>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #27 received at 165897-close@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: 165897-close@bugs.debian.org
Subject: Bug#165897: fixed in ncurses 5.3.20021109-1
Date: Tue, 12 Nov 2002 10:14:13 -0500
We believe that the bug you reported is fixed in the latest version of
ncurses, which is due to be installed in the Debian FTP archive:

libncurses5-dbg_5.3.20021109-1_i386.deb
  to pool/main/n/ncurses/libncurses5-dbg_5.3.20021109-1_i386.deb
libncurses5-dev_5.3.20021109-1_i386.deb
  to pool/main/n/ncurses/libncurses5-dev_5.3.20021109-1_i386.deb
libncurses5_5.3.20021109-1_i386.deb
  to pool/main/n/ncurses/libncurses5_5.3.20021109-1_i386.deb
libncursesw5-dbg_5.3.20021109-1_i386.deb
  to pool/main/n/ncurses/libncursesw5-dbg_5.3.20021109-1_i386.deb
libncursesw5-dev_5.3.20021109-1_i386.deb
  to pool/main/n/ncurses/libncursesw5-dev_5.3.20021109-1_i386.deb
libncursesw5_5.3.20021109-1_i386.deb
  to pool/main/n/ncurses/libncursesw5_5.3.20021109-1_i386.deb
ncurses-base_5.3.20021109-1_all.deb
  to pool/main/n/ncurses/ncurses-base_5.3.20021109-1_all.deb
ncurses-bin_5.3.20021109-1_i386.deb
  to pool/main/n/ncurses/ncurses-bin_5.3.20021109-1_i386.deb
ncurses-term_5.3.20021109-1_all.deb
  to pool/main/n/ncurses/ncurses-term_5.3.20021109-1_all.deb
ncurses_5.3.20021109-1.diff.gz
  to pool/main/n/ncurses/ncurses_5.3.20021109-1.diff.gz
ncurses_5.3.20021109-1.dsc
  to pool/main/n/ncurses/ncurses_5.3.20021109-1.dsc
ncurses_5.3.20021109.orig.tar.gz
  to pool/main/n/ncurses/ncurses_5.3.20021109.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 165897@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Jacobowitz <dan@debian.org> (supplier of updated ncurses package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Mon, 11 Nov 2002 14:58:33 -0500
Source: ncurses
Binary: ncurses-base libncursesw5-dev libncursesw5-dbg ncurses-bin libncurses5 libncursesw5 libncurses5-dev ncurses-term libncurses5-dbg
Architecture: source i386 all
Version: 5.3.20021109-1
Distribution: unstable
Urgency: low
Maintainer: Daniel Jacobowitz <ncurses-maint@debian.org>
Changed-By: Daniel Jacobowitz <dan@debian.org>
Description: 
 libncurses5 - Shared libraries for terminal handling
 libncurses5-dbg - Debugging/profiling libraries for ncurses
 libncurses5-dev - Developer's libraries and docs for ncurses
 libncursesw5 - Shared libraries for terminal handling (wide character support)
 libncursesw5-dbg - Debugging/profiling libraries for ncurses
 libncursesw5-dev - Developer's libraries and docs for ncursesw
 ncurses-base - Descriptions of common terminal types
 ncurses-bin - Terminal-related programs and man pages
 ncurses-term - Additional terminal type definitions
Closes: 163512 165897
Changes: 
 ncurses (5.3.20021109-1) unstable; urgency=low
 .
   * New upstream version (Closes: #163512).
     - Thanks to Andreas for doing a lot of the grunt work.
     - Works around lameness in dpkg's build process (Closes: #165897).
Files: 
 149356b60a6f7056878ad6bc41d22241 725 libs standard ncurses_5.3.20021109-1.dsc
 e8e28a391ce0d49eb7d553a98aa9569c 2072438 libs standard ncurses_5.3.20021109.orig.tar.gz
 a810799bb7e0bb619952ed7a43a2713c 25430 libs standard ncurses_5.3.20021109-1.diff.gz
 1043f00c9dd51760268429a85738db03 249148 base required libncurses5_5.3.20021109-1_i386.deb
 3d695b95f20245970d9cd48a66e03fb3 1031286 devel optional libncurses5-dev_5.3.20021109-1_i386.deb
 b41cca99b99262157867d1ff85d6263e 328300 devel extra libncurses5-dbg_5.3.20021109-1_i386.deb
 8a10ac03888896b780c201446a945c4b 258890 libs optional libncursesw5_5.3.20021109-1_i386.deb
 4aa5cf01e2bb3e11476c08c742dd388c 393036 devel optional libncursesw5-dev_5.3.20021109-1_i386.deb
 b6284443623405e3983de040c7ad2699 351250 devel extra libncursesw5-dbg_5.3.20021109-1_i386.deb
 e6c8d58b6eacb6c8f995dbf587c741b2 196992 base required ncurses-bin_5.3.20021109-1_i386.deb
 2443013743f82f1883bccf6ac938abef 9158 base required ncurses-base_5.3.20021109-1_all.deb
 ae3544f17347a32b5fae56ef0e9c41b7 302872 admin standard ncurses-term_5.3.20021109-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.2.1 (GNU/Linux)

iD8DBQE90E8kbgOPXuCjg3cRAiE0AJ46JfvFI0h7xPsjcqKueEHNOB8r5gCgpNW4
A94zNjddb4YC4BNdMk/MH6s=
=4VSV
-----END PGP SIGNATURE-----




Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 16:47:13 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.